

class classPlayer{
  
  constructor(){
    this.winAmount = {
      3:24,
      4:170,
      5:5300,
      6:1000000
    };
    
    this.hits = {
      '3':0,
      '4':0,
      '5':0,
      '6':0
    };
    this.betPrice = 3 ;
    this.name = '' ;
    this.budget = 0 ;
    this.betList = [] ;
    this.betCount = 0 ;
    this.totalBetCount = 0 ;
    this.lastWinsSum = 0 ;
    this.checkCount = 0 ;
    this.currDrawNumbers = [] ;
  };
  
  renderBets( uid ){
      
    if ( this.betCount > 1000 ) {
      let tmp = `<div class='playerBets' onclick='document.getElementById(\"${uid}\").style.display=\"none\";'>
        <div style='padding:10px;color:#fff;font-weight:bold;line-height:30px;border-bottom:solid 1px #666;'>
          Zbyt dużo zakładów:
        </div></div>`;
      return tmp;
    }
      
    let tmp = `<div class='playerBets' onclick='document.getElementById(\"${uid}\").style.display=\"none\";'>
      <div style='padding:10px;color:#fff;font-weight:bold;line-height:30px;border-bottom:solid 1px #666;'>
        Obstawione zakłady ( w tym losowaniu ):
      </div>
      <div style='clear:both;'></div>` ;
    for ( let betNo = 0 ; betNo < this.betCount ; betNo++ ){
      
      let betNoX = betNo + 1 ;
      
      let isWin = 0 ;
      for ( let i = 0 ; i < this.betList[ betNo ].numbers.length ; i++ ){
        let nextNo = this.betList[ betNo ].numbers[i];
        if ( Tools.inArray( nextNo, this.currDrawNumbers) ) isWin++ ;
      }
      let forceBorder = '' ;
      if ( isWin >= 3 ) forceBorder = 'style="background:#4a4;"';
      
      tmp += `<div class='playerBet' ${forceBorder}><span class='playerBetNo'>${betNoX}</span>`;
      for ( let i = 0 ; i < this.betList[ betNo ].numbers.length ; i++ ){
        let nextNo = this.betList[ betNo ].numbers[i];
        let forceColor = '' ;
        if ( Tools.inArray( nextNo, this.currDrawNumbers) ){
          forceColor = 'style="background:#6f8;"';
        }
        tmp += `<span class='number' ${forceColor}>${nextNo}</span>`;
      }      
      tmp += `</div>`;
    }
    return tmp;
  }  
  
  renderPlayer (){
    
    let extraColor = '' ;
    if ( this.budget < this.betPrice ){
      extraColor = " style='background:red;' ";
    }
    let playerWins = '' ;
    playerWins = `
      <div style='height:20px;color:#bbb;'>Łącznie wygrane:</div>
      <div class='playerWin'>Traf. 3-ki</div>
      <div class='playerWin'>Traf. 4-ki</div>
      <div class='playerWin'>Traf. 5-ki</div>
      <div class='playerWin'>Traf. 6-ki</div>
      <div class='playerWin'>${this.hits[3]}</div>
      <div class='playerWin'>${this.hits[4]}</div>
      <div class='playerWin'>${this.hits[5]}</div>
      <div class='playerWin'>${this.hits[6]}</div>` ;
    
    let lastBetPrice = this.betCount * this.betPrice ;
    
    let uid = Tools.uuidv4();
    let renderedBets = this.renderBets( uid );
    
    let showBetsClick = '' ;
    let showBetsData = '' ;
    let showBetsBtn = '' ;
    if ( this.betCount > 0 ){
      showBetsClick = ` style='cursor:pointer;' onclick='document.getElementById("${uid}").style.display="block";'` ;
      showBetsData = `<div class='playerBets' style='display:none;' id='${uid}'>${renderedBets}</div>` ;
      showBetsBtn = `<u style=''>Zobacz zakłady.</u>` ;
    }
    let tmp = `<div class='playerContainer' ${extraColor}>
    <div class='playerName' ${showBetsClick}>
      ${this.name}<br>Łącznie obstawiono zakładów: ${this.totalBetCount}
      <br>Wzięto udział w ${this.checkCount} losowaniach.
      <div style='margin-top:4px;background:#fff;color:#333;padding:2px;border-radius:3px;'>&nbsp;${showBetsBtn}</div>
    </div>
      <div class='playerBudget'>Wygranych w tym losowaniu: <b>${this.lastWinsSum} zł</b></div>
      <div class='playerBudget'>Koszt gry / tego losowania: <b>-${lastBetPrice} zł</b></div>
      <div class='playerBudget'>Pozostało budżetu: <b>${this.budget} zł</b></div>
      <div class='playerWins'>${playerWins}</div>
      ${showBetsData}
    </div>`;
    return tmp;
  }
  
  resetBets(){
    this.betList = [] ;
    this.betCount = 0 ;
    this.lastWinsSum = 0 ;
  }
  
  addBet( numbers ){
    if ( this.budget < this.betPrice ) return;
    this.betList [ this.betCount ] = new classBet();
    this.betList [ this.betCount ].setManual ( numbers );
    this.budget = this.budget - this.betPrice ;
    this.betCount++;
    this.totalBetCount++;
  }
  
  check( currDrawNumbers  ){
    if ( this.betCount == 0 ) return ;
    this.currDrawNumbers = currDrawNumbers ;
    
    this.checkCount++;
    for ( let i = 0; i < this.betCount ; i++ ){
      let hit = this.betList[ i ].check ( currDrawNumbers  );      
      if ( ( hit >= 3 )&&( hit <=6 ) ){
        this.hits [ hit ]++ ;
        this.budget += this.winAmount [ hit ] ;
        this.lastWinsSum += this.winAmount [ hit ] ;
      }
    }
  }
   
  
  
  
}