var Tools = new classTools();
var Draw = new classDraw( 1, 49, 6 );

class classSimApp {
  
  constructor(){
    this.players = [] ;
    this.initialBudget = 1000 ;
    this.totalDrawLimit = 1000 ;
  }
  
  showSectionMain(){
    document.getElementById ( 'main' ).style.display = 'block' ;
  }
  
  showDraw ( drawNumbers, title ){
    var iDiv = document.createElement('div');
    iDiv.id = 'block';
    iDiv.className = 'block';
    document.getElementById('main').appendChild(iDiv);
    let numList = '' ;
    for ( let i = 0 ; i < drawNumbers.length ; i++ ){
      numList += `<span class='number'>${drawNumbers[i]}</span>`;
    }
    iDiv.innerHTML = `<div><span class='drawTitle'>${title}</span><div class='drawNumbers'>${numList}</div></div>`;
  }

  showPlayers( divDestName, forceShow ){
    
    if ( forceShow === undefined ) forceShow = false ;
    let tmpTable = `<table class='playersTable'><tr>`;
    
    for ( let i = 0 ; i < this.players.length ; i++ ){
      let tmpPlayer = this.players[ i ].renderPlayer();
      tmpTable += `<td style='width:calc(100% / ${this.players.length})'>${tmpPlayer}</td>`;
    }
    
    var iDiv = document.createElement('div');
    iDiv.id = 'block';
    iDiv.className = 'block';
    document.getElementById( divDestName ).appendChild(iDiv);
    let numList = '' ;
    iDiv.innerHTML = tmpTable;
    
  }

  definePlayers(){
    //
    // Definiujemy graczy.
    //
    this.players[0] = new classPlayer();
    this.players[0].name = 'Anita' ;
    this.players[0].budget = this.initialBudget ;

    this.players[1] = new classPlayer();
    this.players[1].name = 'Danuta' ;
    this.players[1].budget = this.initialBudget ;

    this.players[2] = new classPlayer();
    this.players[2].name = 'Elżbieta' ;
    this.players[2].budget = this.initialBudget ;
  }
  
  definePlayersBets(){
    // gracz 1
    this.players[0].addBet( Draw.getRandom() );
    this.players[0].addBet( Draw.getRandom() );

    // gracz 2
    this.players[1].addBet( [  1,  2,  3,  4,  5,  6 ] );
    this.players[1].addBet( [  2,  3,  4,  5,  6,  7 ] );
     
    // gracz 3
    this.players[2].addBet( [  1,  2,  3,  4,  5,  6 ] );
    this.players[2].addBet( [  7,  8,  9, 10, 11, 12 ] );
  }
  
  run(){

    this.definePlayers();
    this.showPlayers( 'header', true );

    //
    // pętla losowań
    //
    for ( let drawNo = 1 ; drawNo < this.totalDrawLimit ; drawNo++ ){

      //
      // resetujemy zakłady graczy
      for ( let playerNo = 0 ; playerNo < this.players.length ; playerNo++ ){       
        this.players[ playerNo ].resetBets () ;
      }

      //
      // gracze obstawiają nowe zakłady
      this.definePlayersBets();
   
      //
      // losowanie liczb
      let currDrawNumbers = Draw.getRandom();
      
      //
      // sprawdzam wyniki    
      let nextDrawPossible = false ;
      for ( let playerNo = 0 ; playerNo < this.players.length ; playerNo++ ){
        this.players[ playerNo ].check ( currDrawNumbers ) ;   
        if ( this.players[ playerNo ].budget >= this.players[ playerNo ].betPrice  ) {
          nextDrawPossible = true ;
        }
      }
      
      //
      // wyświetlam losowanie i poszczególnych graczy   
      this.showDraw( currDrawNumbers, `Losowanie ${drawNo}` );
      this.showPlayers( 'main' );
      
      //
      // sprawdzam czy jeszcze któryś z graczy ma kasę na dalszą grę.
      if ( nextDrawPossible == false ){
        break ;
        console.log ( 'break', drawNo ) ;
      }

    }
    
    //
    // wyświetlam podsumowanie
    this.showPlayers( 'footer', true );
    
  }
  
}
